/**********************************************************************************
 * Header file for the implementation of the algorithm for
 * computing rearrangement distance of all permutations of size n.
 * Author : Gustavo Rodrigues Galvao - May 2010.
**********************************************************************************/

#ifndef COMMONS
#define COMMONS

#include <pthread.h>
#include <stdlib.h>
#include "util.h"
#include "ranking.h"

char *hash;
int *slices, currentSlice;
pthread_mutex_t mutexCommonData, mutexSlices;
unsigned int indexFirst, indexLast, *queue;

typedef struct tThread_args{
	int n, sign, assimetryLevel;
	void(*loadVector)(int,int*,int*,int*,tPermutation*,unsigned int*,int);
}tThread_args;

void generateAllPermutations(int n, int sign, int num_threads, int assimetryLevel, int printASCII, void *loadVector);

unsigned int nextReversal(tPermutation *permutation, int *temp, int *copy, int i, int j);

unsigned int nextTransposition(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned int nextTransreversalA(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned int nextTransreversalB(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned int nextSignedTransreversalA(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned int nextSignedTransreversalB(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned int nextBlockInterchange(tPermutation *permutation, int *temp, int *copy, int i, int j, int k, int l);

unsigned int nextSignedReversal(tPermutation *permutation, int *temp, int *copy, int i, int j);

unsigned int nextCenteredReversal(tPermutation *permutation, int *temp, int *copy, int i, int j);

unsigned int nextSignedCenteredReversal(tPermutation *permutation, int *temp, int *copy, int i, int j);

unsigned int nextSwap(tPermutation *permutation, int *temp, int *copy, int i, int j);

#endif
