/**********************************************************************************
 * Source file for the implementation of the algorithm for
 * computing rearrangement distance of all permutations of size n.
 * Author : Gustavo Rodrigues Galvo - May 2010.
**********************************************************************************/


#include <stdio.h>
#include "util.h"

unsigned int rank(int n, int *pi, int *invpi){
	int s;

	if(n == 1){
		return 0;
	}

	s = pi[n-1]-1;
	swap(pi,n-1,invpi[n-1]-1);
	swap(invpi,s,n-1);

	return (s + n*rank(n-1,pi,invpi));
}

void unrank(int n, unsigned int r, int *pi){
	if(n > 0){
		swap(pi,n-1,r%n);
		unrank(n-1,r/n,pi);
	}
}
