/**********************************************************************************
 * Source file for the implementation of the algorithm for
 * computing rearrangement distance of all permutations of size n.
 * Author : Gustavo Rodrigues Galv�o - May 2010.
**********************************************************************************/


#include "util.h"

void swap(int *v, int i, int j){
	int temp;

	temp = v[i];
	v[i] = v[j];
	v[j] = temp;
}

unsigned int factorial(int n){
	int i;
	unsigned int fat;

	fat = 1;
	for(i = 2; i <=n; i++){
		fat = fat*i;
	}

	return fat;
}

int pow2(int n){
	int i,p;

	p = 1;
	for(i = 1; i <= n; i++){
		p = 2*p;
	}

	return p;
}

void getBase2(unsigned int *base2, int n){
	int i;

	base2[0] = 1;
	for(i = 1; i < n; i++){
		base2[i] = 2*base2[i-1];
	}
}

int isnumeric(char *str)
{
  while(*str)
  {
    if(!isdigit(*str))
      return 0;
    str++;
  }

  return 1;
}

void initializeHash(char *hash, unsigned int n){
	unsigned int i;

	for(i = 0; i < n; i++){
		hash[i] = (char) 255;
	}
}

void initializeVector(int *vector, int n){
	int i;

	for(i = 0; i < n; i++){
		vector[i] = 0;
	}
}

void printPermutation(tPermutation *permutation){
  int i;

  for(i = 0; i < permutation->n - 1; i++){
	  printf("%d,",permutation->elements[i]);
  }
  printf("%d",permutation->elements[i]);
}

void printOutput(tPermutation *p, int d){
	printPermutation(p);
	printf(" %d\n",d);
}

void printIntVector(int *vector, int n){
	int i;

	for(i = 0; i < n; i++){
		printf("%d ",vector[i]);
	}
}
