/**********************************************************************************
 * Header file for the implementation of the algorithm for
 * computing rearrangement distance of all permutations of size n.
 * Author : Gustavo Rodrigues Galvao - May 2010.
**********************************************************************************/

#ifndef COMMONS
#define COMMONS

#include <pthread.h>
#include <stdlib.h>
#include "util.h"
#include "ranking.h"

char *hash;
int *slices, currentSlice;
pthread_mutex_t mutexCommonData, mutexSlices;
unsigned long indexFirst, indexLast, *queue;

typedef struct tThread_args{
	int n, sign, assimetryLevel;
	void(*loadVector)(int,int*,int*,int*,tPermutation*,unsigned long*,int);
}tThread_args;

void generateAllPermutations(int n, int sign, int num_threads, int assimetryLevel, int printASCII, void *loadVector);

unsigned long nextReversal(tPermutation *permutation, int *temp, int *copy, int i, int j);

unsigned long nextTransposition(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned long nextTransreversalA(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned long nextTransreversalB(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned long nextSignedTransreversalA(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned long nextSignedTransreversalB(tPermutation *permutation, int *temp, int *copy, int i, int j, int k);

unsigned long nextBlockInterchange(tPermutation *permutation, int *temp, int *copy, int i, int j, int k, int l);

unsigned long nextSignedReversal(tPermutation *permutation, int *temp, int *copy, int i, int j);

unsigned long nextCenteredReversal(tPermutation *permutation, int *temp, int *copy, int i, int j);

unsigned long nextSignedCenteredReversal(tPermutation *permutation, int *temp, int *copy, int i, int j);

unsigned long nextSwap(tPermutation *permutation, int *temp, int *copy, int i, int j);

#endif
